
//------------------------------------------------------------------------------
// Copyright (c) 2006 by AUDACIA Software
//------------------------------------------------------------------------------

package com.audacia.opentools.a86viewer;

import com.borland.primetime.PrimeTime;
import com.borland.primetime.node.*;
import com.borland.primetime.vfs.Url;


public class A86FileNode extends TextFileNode {

  public static void initOpenTool(byte majorVersion, byte minorVersion) {
    if (majorVersion == PrimeTime.CURRENT_MAJOR_VERSION) {
      registerFileNodeClass("asm", "x86 Assembler file",
          A86FileNode.class, ICON);
      registerFileNodeClass("a86", "x86 Assembler file",
          A86FileNode.class, ICON);
    }
  }

  public A86FileNode(Project project, Node parent, Url url)
      throws DuplicateNodeException {
    super(project, parent, url);
  }

  public Class getEditorKitClass() {
    return A86EditorKit.class;
  }

  public Class getTextStructureClass() {
    return A86Structure.class;
  }
}
