
//------------------------------------------------------------------------------
// Copyright (c) 2006 by AUDACIA Software
//------------------------------------------------------------------------------

package com.audacia.opentools.casiopv.addinwiz;

import java.util.*;

import com.borland.cbuilder.node.*;
import com.borland.primetime.*;
import com.borland.primetime.help.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.node.*;
import com.borland.primetime.properties.*;
import com.borland.primetime.runtime.*;
import com.borland.primetime.build.*;

public class AddInRunner implements Runner {

  public static final String CATEGORY = "runtime";


    public static void initOpenTool(byte majorVersion, byte minorVersion) {
    if (majorVersion == PrimeTime.CURRENT_MAJOR_VERSION) {
      RuntimeManager.registerRunner (AddInRunner.RUNNER_NewAddInRunner ());
    }
  }


  public static Runner RUNNER_NewAddInRunner () {
    return new AddInRunner();
  }

  public AddInRunner() {
    dllLoaded = false;
  }

  public PropertyPageFactory getPageFactory (Project project, Map map) {
    return new MyPropertyPageFactory (this, map);
  }

  public boolean isValid(Browser browser, Project project, Map map,
                         boolean _boolean) {
    return true;
  }

  public void run(Browser browser, Project project, Map map, boolean debug) {
    CBProject cbp = (CBProject) project;

    loadDLL ();
    AddInJNIComm.runPVSDKProject (cbp.getDisplayName(), cbp.getProjectPath().getFile().toString(), debug);
  }

  private boolean dllLoaded;
  private void loadDLL() {
    if (!dllLoaded)
    {
      try {
        System.loadLibrary("pvwizjni");
      }
      catch (Exception ex) {
      }
    }
  }

  class MyPropertyPageFactory extends PropertyPageFactory {


    public MyPropertyPageFactory (AddInRunner addInRunner, Map map) {
      super ("PV2 Simulator");
    }

    class MyPropertyPage extends PropertyPage {
      public MyPropertyPage () {
        super ();
      }

      public HelpTopic getHelpTopic() {
        return null;
      }

      public void writeProperties() {
      }

      public void readProperties() {
      }

      public boolean isPageValid() {
        return true;
      }

    }

    public PropertyPage createPropertyPage() {
      return new MyPropertyPage();
    }
  }
}



