
//------------------------------------------------------------------------------
// Copyright (c) 2007 by AUDACIA Software
//------------------------------------------------------------------------------

package com.audacia.opentools.casiopv.addinwiz;

import javax.swing.*;

import com.borland.cbuilder.node.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.node.*;
import com.borland.primetime.util.*;
import com.borland.primetime.vfs.*;
import com.borland.primetime.wizard.*;


public class AddLibWizard extends BasicWizard {

  public static final WizardAction WIZARD_AddLib = new WizardAction (
    "Add Library", 'L', "Adds a library to the project",
    new ImageIcon(Images.getImage(AddLibWizard.class,
      "image/addlib16.gif")),
    new ImageIcon(Images.getImage(AddLibWizard.class,
      "image/addlib.gif")),
      false, "PocketViewer") {
    // override method so wizard disabled if no project active
    public void update(Object source) {
      Browser browser = Browser.findBrowser(source);
      Project project = browser.getProjectView().getActiveProject();
      setEnabled(project != null);
    }
    protected Wizard createWizard() {
      return new AddLibWizard();
    }
  };


  public AddLibWizard() {
    super();
  }

  public WizardPage invokeWizard(WizardHost host) {
    setWizardTitle("Add Library Wizard");
    namePage = new AddLibWizardPage();
    addWizardPage(namePage);
    return super.invokeWizard(host);
  }


  protected static Url makeFileUrl(CBProject project,
                                   String subdirName,
                                   String fileName)
  {
    try {
      return new Url(project.getProjectPath() + "/" + subdirName + "/" +
                     fileName);
    }
    catch (InvalidUrlException ex) {
      return null;
    }
  }

  protected static FileNode createNode(CBProject project,
                                       String fileName)
  {
    LightweightNode[] lwn;
    Node fn = project;
    Url filePath = makeFileUrl (project, null, fileName);
    FileNode newNode = project.getNode (filePath);
    String nodeToFind = "Libraries";

    lwn = project.findNodes (FolderNode.class);
    for (int i = lwn.length - 1; i >= 0; --i)
    {
      if (lwn[i].getName ().equals (nodeToFind))
        fn = lwn[i];
    }
    newNode.setParent (fn);
    return newNode;
  }


  protected void finish() throws VetoException {
    if (namePage.getLibraryName ().equals ("<no libraries>"))
      throw new VetoException ();

    Browser browser = Browser.getActiveBrowser ();
    CBProject project = (CBProject) browser.getProjectView ().getActiveProject ();
    createNode (project, namePage.getLibraryName () + (".lib"));
  }

  public void wizardCompleted() {
  }


  private AddLibWizardPage namePage;
}
