
//------------------------------------------------------------------------------
// Copyright (c) 2006 by AUDACIA Software
//------------------------------------------------------------------------------

package com.audacia.opentools.casiopv.addinwiz;

import java.io.*;

import javax.swing.*;

import com.borland.primetime.ide.*;
import com.borland.primetime.node.*;
import com.borland.primetime.util.*;
import com.borland.primetime.vfs.*;
import com.borland.primetime.wizard.*;


public class LibraryWizard extends BasicWizard {

  public static final WizardAction WIZARD_NewLibrary = new WizardAction (
    "New Library", 'L', "Creates a new Add-In library",
    BrowserIcons.ICON_PROJECT,
    new ImageIcon(Images.getImage(LibraryWizard.class,
      "image/lib32.gif")),
      true, "PocketViewer") {
    protected Wizard createWizard() {
      return new LibraryWizard();
    }
  };

  public LibraryWizard() {
    super();
    try {
      System.loadLibrary ("pvwizjni");
    }
    catch (Exception ex) {
    }
  }

  public WizardPage invokeWizard(WizardHost host) {
    setWizardTitle("New PV Add-In Library Wizard");
    namePage = new ProjectWizardNamePage (true);
    addWizardPage(namePage);
    return super.invokeWizard(host);
  }


  protected void finish() throws VetoException {
    Browser browser = Browser.getActiveBrowser();
    ProjectGroup pg = browser.getActiveProjectGroup();
    Project pr = null;

    String ProjBaseDir;
    String ProjName = namePage.getName();
    String ProjDir;

    ProjBaseDir = AddInJNIComm.getPV2SDKPath () + "\\C";
    ProjDir = ProjBaseDir + "\\" + ProjName;

    if (!AddInJNIComm.createPVSDKProject (ProjName, true))
      throw new com.borland.primetime.util.VetoException ();

    browser.doOpen (new Url (new File (ProjDir + "\\" + ProjName + ".cbx")), null, true);
    pr = browser.getActiveProject ();
    if ((pg != null) && namePage.getAddToProjGroup ())
    {
      pg.addProject (pr);
      try {
        browser.closeProject(pr);
        browser.setActiveProject (pg, pr);
      }
      catch (Exception ex) {
      }
    }
  }

  public void wizardCompleted() {
  }



  private ProjectWizardNamePage namePage;
}
