
//------------------------------------------------------------------------------
// Copyright (c) 2006 by AUDACIA Software
//------------------------------------------------------------------------------

package com.audacia.opentools.casiopv.addinwiz;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import com.borland.primetime.ide.*;
import com.borland.primetime.util.*;
import com.borland.primetime.wizard.*;


public class ProjectWizardNamePage extends BasicWizardPage {

  public ProjectWizardNamePage(boolean library) {
    isLibrary = library;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }



  public String getName() {
    return this.projectName.getText();
  }
  public boolean getAddToProjGroup() {
    return jAddToActiveProjectGroup.isSelected ();
  }


  protected JTextField projectName = new JTextField ();
  protected JLabel noteLabel = new JLabel();
  FlowLayout flowLayout = new FlowLayout();
  JPanel jPanel = new JPanel();
  FlowLayout flowLayout2 = new FlowLayout();
  JCheckBox jAddToActiveProjectGroup = new JCheckBox();
  Border border2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,
  new Color(148, 145, 140)), "Project name");


  protected void jbInit() throws Exception {
    this.setLayout(flowLayout);


    this.setPageTitle(isLibrary
                    ? "CASIO PocketViewer Add-In Library Project"
                    : "CASIO PocketViewer Add-In Project");
    this.setLargeIcon(new ImageIcon(Images.getImage(ProjectWizardNamePage.class, isLibrary
                                                                             ? "image/pvs1600.gif"
                                                                             : "image/pv-s460.gif")));
    this.setInstructions("Please input the project name:");

    projectName.setPreferredSize(new Dimension(320, 20));
    projectName.setText (isLibrary ? "Library1" : "AddIn1");

    noteLabel.setPreferredSize(new Dimension(320, 30));
    noteLabel.setText("The project will be created in the PV2SDK\'s \"C\" subdirectory.");

    jPanel.setPreferredSize(new Dimension(350, 82));
    jPanel.setLayout(flowLayout2);
    jPanel.setBorder(BorderFactory.createEtchedBorder());

    jAddToActiveProjectGroup.setPreferredSize(new Dimension(350, 30));
    jAddToActiveProjectGroup.setText("Add project to active project group");
    if (Browser.getActiveBrowser().getActiveProjectGroup () == null)
    {
      jAddToActiveProjectGroup.setSelected(false);
      jAddToActiveProjectGroup.setEnabled(false);
    }
    else
      jAddToActiveProjectGroup.setSelected(true);

    jPanel.add(projectName);
    jPanel.add(noteLabel);
    jPanel.setBorder(border2);

    this.add(jPanel);
    this.add(jAddToActiveProjectGroup);

    this.setMaximumSize(new Dimension(364, 315));
    this.setPreferredSize(new Dimension(364, 315));
    this.setMinimumSize(new Dimension(364, 315));
    this.setSize (364, 315);

  }

  private boolean isLibrary;
}
