; PV Add-In Toolkit - Installer Script
; (c) 2007 by AUDACIA Software



[Setup]
AppName=PV Add-In Toolkit
AppVerName=PV Add-In Toolkit v1.02

AllowRootDirectory=true
AllowNoIcons=true
AlwaysShowDirOnReadyPage=true
AlwaysShowGroupOnReadyPage=true

AppPublisher=AUDACIA Software
AppPublisherURL=http://www.audacia-software.de/
AppVersion=1.00
AppId={{5B88B4EA-92DE-4CA6-9B41-7799A920F445}
AppCopyright=(c) 2007 by AUDACIA Software

LicenseFile=licenseEN.rtf
Uninstallable=true
InternalCompressLevel=ultra
VersionInfoVersion=1.02
VersionInfoCompany=AUDACIA Software
VersionInfoCopyright=(c) 2007 by AUDACIA Software
InfoBeforeFile=info.rtf
ShowLanguageDialog=no
UninstallDisplayName=PV Add-In Toolkit
CreateAppDir=false
DisableProgramGroupPage=true



[Types]
Name: custom; Description: Custom installation; Flags: iscustom



[Components]
Name: bcbx10; Description: C++BuilderX 1.0 Integration; Types: custom
Name: bcbx15; Description: C++BuilderX 1.5 Integration; Types: custom



[Tasks]



[Dirs]
Name: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\templates\PVSDK; Components: bcbx10
Name: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\toolsets\PVSDK; Components: bcbx10

Name: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\templates\PVSDK; Components: bcbx15
Name: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\toolsets\PVSDK; Components: bcbx15



[Files]
Source: files\ATFLASH32.BIN; DestDir: {code:getPV2SDKPath}\SIM
Source: files\ATSRAM.BIN; DestDir: {code:getPV2SDKPath}\SIM
Source: files\APLAT.BIN; DestDir: {code:getPV2SDKPath}\C\BIN
Source: files\ATBIOS.00; DestDir: {code:getPV2SDKPath}\BIOS

Source: files\pvwizjni.dll; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\bin; Components: bcbx10
Source: files\pvbuild.exe; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\toolsets\PVSDK; Components: bcbx10
Source: files\Settings.ini; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\toolsets\PVSDK; Components: bcbx10; AfterInstall: SetSettingsINIPaths
Source: files\AddInWiz.jar; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\lib\ext; Components: bcbx10
Source: files\a86viewer.jar; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\lib\ext; Components: bcbx10
Source: files\templates\*.*; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\templates\PVSDK; Components: bcbx10; Flags: recursesubdirs createallsubdirs
Source: files\win32b.toolset; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\toolsets; Components: bcbx10; BeforeInstall: BackupCurrentFile
Source: files\pvbuild.tool; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.0,PathName}\toolsets\win32b; Components: bcbx10

Source: files\pvwizjni.dll; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\bin; Components: bcbx15
Source: files\pvbuild.exe; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\toolsets\PVSDK; Components: bcbx15
Source: files\Settings.ini; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\toolsets\PVSDK; Components: bcbx15; AfterInstall: SetSettingsINIPaths
Source: files\AddInWiz.jar; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\lib\ext; Components: bcbx15
Source: files\a86viewer.jar; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\lib\ext; Components: bcbx15
Source: files\templates\*.*; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\templates\PVSDK; Components: bcbx15; Flags: recursesubdirs createallsubdirs
Source: files\win32b.toolset; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\toolsets; Components: bcbx15; BeforeInstall: BackupCurrentFile
Source: files\pvbuild.tool; DestDir: {reg:HKLM\SOFTWARE\Borland\C++BuilderX\1.5,PathName}\toolsets\win32b; Components: bcbx15



[Registry]
Root: HKLM; Subkey: Software\AUDACIA; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: Software\AUDACIA\PV Add-In Toolkit; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: Software\AUDACIA\PV Add-In Toolkit\Integration; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: Software\AUDACIA\PV Add-In Toolkit\Integration; ValueType: string; ValueName: C++BuilderX 1.0; ValueData: ; Flags: uninsdeletevalue
Root: HKLM; Subkey: Software\AUDACIA\PV Add-In Toolkit\Integration; ValueType: string; ValueName: C++BuilderX 1.5; ValueData: ; Flags: uninsdeletevalue
Root: HKLM; Subkey: Software\AUDACIA\PV Add-In Toolkit; ValueType: dword; ValueName: Version; ValueData: 102; Flags: uninsdeletevalue





[Code]
const
	defaultPV2SDKPath = 'C:\CASIO\PV2EN03';
	defaultPV3SDKPath = 'C:\CASIO\PV3S1600';
	PV2SDKKey = 'SOFTWARE\CASIO COMPUTER CO.,LTD\PV2SDK-EN03';
	PV3SDKKey = 'SOFTWARE\CASIO COMPUTER CO,.LTD.\PV-S1600 Software Development Kit';

	msgPV2SDKNotFound = 'PV2SDK-EN03 not found.'#13#10 + 'Please install PV2SDK-EN03 before installing PV Add-In Toolkit.';
	msgPV2SDKPathPrompt = 'Please select PV2SDK-EN03 directory:';
	msgPV3SDKNotFound = 'PV-S1600 SDK not found.'#13#10 + 'Please install PV-S1600 SDK before installing PV Add-In Toolkit.';
	msgPV3SDKPathPrompt = 'Please select PV-S1600 SDK directory:';

var
	PV2SDKpath : String;
	PV3SDKpath : String;



function getPV2SDKPath (Param : String) : String;
begin
	if PV2SDKpath = '' then
	begin
		PV2SDKpath := defaultPV2SDKPath;
		if not BrowseForFolder (msgPV2SDKPathPrompt, PV2SDKpath, true) then
			Abort;
	end;
	result := PV2SDKpath;
end;
function getPV3SDKPath (Param : String) : String;
begin
	if PV3SDKpath = '' then
	begin
		PV3SDKpath := defaultPV3SDKPath;
		if not BrowseForFolder (msgPV3SDKPathPrompt, PV3SDKpath, true) then
			Abort;
	end;
	result := PV3SDKpath;
end;


procedure SetSettingsINIPaths ();
begin
	SetIniString ('PV2SDK Paths', 'SDKPath', getPV2SDKPath (''), CurrentFileName);
	SetIniString ('PV3SDK Paths', 'SDKPath', getPV3SDKPath (''), CurrentFileName);
end;

procedure BackupCurrentFile ();
begin
	FileCopy (CurrentFileName, CurrentFileName + '.bak', false);
end;


function InitializeSetup () : Boolean;
begin
	PV2SDKpath := '';
	PV3SDKpath := '';
	result := true;
end;

procedure InitializeWizard ();
var
	cbx10av, cbx15av : Boolean;
begin
	cbx10av := RegKeyExists (HKEY_LOCAL_MACHINE, 'SOFTWARE\Borland\C++BuilderX\1.0');
	cbx15av := RegKeyExists (HKEY_LOCAL_MACHINE, 'SOFTWARE\Borland\C++BuilderX\1.5');

	WizardForm.ComponentsList.Checked[0] := cbx10av;
	WizardForm.ComponentsList.Checked[1] := cbx15av;
	if not cbx10av then
		WizardForm.ComponentsList.ItemEnabled[0] := false;
	if not cbx15av then
		WizardForm.ComponentsList.ItemEnabled[1] := false;
end;


function NextButtonClick(CurPageID: Integer): Boolean;
var
	pv2installed, pv3installed : Boolean;
begin
	case CurPageID of
	wpInfoBefore:
		begin
			pv2installed := RegKeyExists (HKEY_LOCAL_MACHINE, PV2SDKKey);
			if not pv2installed then
				MsgBox (msgPV2SDKNotFound, mbError, MB_OK)
			pv3installed := RegKeyExists (HKEY_LOCAL_MACHINE, PV3SDKKey);
			if not pv3installed then
				MsgBox (msgPV3SDKNotFound, mbError, MB_OK)
			result := pv2installed and pv3installed;
		end;

	wpSelectComponents:
			result := (WizardSelectedComponents (false) <> '');

	else
		result := true;
	end;
end;
