<?xml version="1.0" encoding="UTF-8"?>
<!--C++BuilderX External Tool Definition File-->

<tool key="pvbuild">
  <name>PVBUILD</name>
  <desc>PV SDK Build Tool</desc>

  <basecmd key="pvbuild_key">
    <name>PV SDK Build Tool</name>
    <command>$(BCBX)\toolsets\PVSDK\pvbuild.exe</command>
  </basecmd>

  <projecttool>0</projecttool>

  <inputext ext="pvmak">
    <platform key="win32">
      <outputext>obj</outputext>
      <outputext>map</outputext>
      <outputext>hex</outputext>
      <outputext>bin</outputext>
    </platform>
  </inputext>

  <outputparser>
  <patternlist>
    <pattern type="warning">
      <regexpression>([a-zA-Z/\\]+(.*))\s+(\d+):(\s+)Warning:(\s+)((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>1</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>6</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="warning">
      <regexpression>(.*)(\x28)(\d+)(\x29)(\s+):(\s+)(.*)(\s+)(.*)(\x28)W(\x29)(\s+)((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>1</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>helpid</groupname>
        <groupindex>7</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>13</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="error">
      <regexpression>(\x2a+)(\s+)(.)(\d{4})(\s+)(\x28)E(\x29)(\s+)((.*))</regexpression>
      <groupdescriptor>
        <groupname>helpid</groupname>
        <groupindex>4</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>9</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="error">
      <regexpression>(.*)(\x28)(\d+)(\x29)(\s+):(\s+)(.*)(\s+)(.*)(\x28)[EF](\x29)(\s+)((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>1</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>helpid</groupname>
        <groupindex>7</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>13</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="error">
      <regexpression>([a-zA-Z/\\]+(.*))\s+(\d+):\s+((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>1</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>4</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="error">
      <regexpression>(.*)(\x28)(.*)(\x29)(\x2c)(\s*)((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>7</groupindex>
      </groupdescriptor>
    </pattern>
    <pattern type="error">
      <regexpression>(.*)(\x28)(.*)(\x29):(\s+)((.*))</regexpression>
      <groupdescriptor>
        <groupname>filename</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>linenumber</groupname>
        <groupindex>3</groupindex>
      </groupdescriptor>
      <groupdescriptor>
        <groupname>message</groupname>
        <groupindex>6</groupindex>
      </groupdescriptor>
    </pattern>
  </patternlist>
  </outputparser>

  <optionparamgroup>
  <option key="d">
    <name>Perform debug build</name>
    <desc>Perform debug build</desc>
    <enabled>-d</enabled>
    <project>1</project>
  </option>

  <option key="l">
    <name>Build library</name>
    <desc>Build library</desc>
    <project>1</project>
    <enabled>-l</enabled>
  </option>
  <option key="a">
    <name>ASM optimisation</name>
    <desc>ASM optimisation</desc>
    <project>1</project>
    <enabled>-a</enabled>
  </option>
  <option key="zs">
    <name>Small memory model</name>
    <desc>Small memory model</desc>
    <project>1</project>
    <enabled>-zs</enabled>
  </option>
  <option key="zp">
    <name>Large memory model</name>
    <desc>Large memory model</desc>
    <project>1</project>
    <enabled>-zp</enabled>
  </option>

  <option key="m">
    <name>Build Makefile</name>
    <desc>Build Makefile</desc>
    <project>1</project>
    <enabled>-m</enabled>
    <disabled>-m-</disabled>
  </option>
  <option key="p2">
    <name>SDK for old PV models (PV2SDK)</name>
    <desc>SDK for old PV models (PV2SDK)</desc>
    <project>1</project>
    <enabled>-p2</enabled>
  </option>
  <option key="p3">
    <name>SDK for PV-S1600 (PV3SDK)</name>
    <desc>SDK for PV-S1600 (PV3SDK)</desc>
    <project>1</project>
    <enabled>-p3</enabled>
  </option>
  <option key="vxxx">
    <name>Version</name>
    <desc>Version</desc>
    <enabled>-v</enabled>
    <arg type="text">
      <name>Version</name>
      <desc>Program version</desc>
      <ismerge>0</ismerge>
    </arg>
    <project>1</project>
  </option>
  <option key="txxx">
    <name>Target segment (PV2SDK only)</name>
    <desc>Target segment (PV2SDK only)</desc>
    <enabled>-t</enabled>
    <arg type="text">
      <name>Target segment</name>
      <desc>Target segment</desc>
      <ismerge>0</ismerge>
    </arg>
    <project>1</project>
  </option>
  <option key="n">
    <name>Application name</name>
    <desc>Application name</desc>
    <enabled>-n</enabled>
    <arg type="text">
      <name>Application name</name>
      <desc>Application name</desc>
      <ismerge>0</ismerge>
    </arg>
    <project>1</project>
  </option>
  <option key="D">
    <name>Conditional defines</name>
    <desc>Define "name" to the null string</desc>
    <enabled>-D</enabled>
    <arg type="stringlist">
      <name>Define name</name>
      <desc>Conditional defines</desc>
      <ismerge>1</ismerge>
      <split>1</split>
      <separator>;</separator>
    </arg>
    <project>1</project>
    <infoid>conditionaldefine</infoid>
  </option>
  <param key="filenames" type="filelist">
    <name>Filename to process</name>
    <desc>List of files to process</desc>
    <presep> </presep>
    <useospathsep>0</useospathsep>
    <project>1</project>
    <separator> </separator>
    <infoid>input</infoid>
    <showondefaultpropertypage>0</showondefaultpropertypage>
  </param>
  </optionparamgroup>



  <layoutgroup key="Settings" grouptype="settingscheckbox">
    <name>General settings</name>
    <desc>General settings</desc>
    <option key="vxxx"/>
    <option key="m"/>
    <option key="n"/>
  </layoutgroup>
  <layoutgroup key="BuildOptions" grouptype="settingscheckbox">
    <name>Build options</name>
    <desc>Build options</desc>
    <option key="l"/>
    <option key="a"/>
    <option key="txxx"/>
  </layoutgroup>
  <layoutgroup key="SDKSettings" grouptype="settingsradiobutton">
    <name>SDK Settings</name>
    <desc>SDK Settings</desc>
    <option key="p2"/>
    <option key="p3"/>
  </layoutgroup>
  <layoutgroup key="MemoryModel" grouptype="settingsradiobutton">
    <name>Memory model (PV2SDK only)</name>
    <desc>Memory model (PV2SDK only)</desc>
    <option key="zs"/>
    <option key="zp"/>
  </layoutgroup>
  <layoutgroup key="Conditional" grouptype="settingscheckbox">
    <name>Conditional defines</name>
    <desc>Conditional defines</desc>
    <option key="D"/>
  </layoutgroup>
  <layoutgroup key="Debugging" grouptype="settingscheckbox">
    <name>Debug</name>
    <desc>Perform debug build</desc>
    <option key="d"/>
  </layoutgroup>



  <!-- Settings section -->
  <setting key="default">
    <name>Default project settings</name>
    <desc>Default settings for all projects builds</desc>
    <defenabledbuildconfig>Release build</defenabledbuildconfig>
    <defenabledbuildconfig>Debug build</defenabledbuildconfig>

  </setting>
  <setting key="debug">
    <name>Debug information (full)</name>
    <desc>Settings for a project build with full debug information</desc>
    <defenabledbuildconfig>Debug build</defenabledbuildconfig>
    <option key="d"/>
    <option key="v">
      <arg>
        <value>100</value>
        <merge>1</merge>
      </arg>
    </option>
  </setting>
  <setting key="release">
    <name>Release project settings</name>
    <desc>Settings for a release project build</desc>
    <defenabledbuildconfig>Release build</defenabledbuildconfig>
    <option key="v">
      <arg>
        <value>100</value>
        <merge>1</merge>
      </arg>
    </option>
  </setting>

</tool>
