
#include <fstream>
#include <string>
#include <string.h>
#include <vector>
#include <cstdarg>
#include <cstdlib>


#include <windows.h>
#pragma hdrstop


#include "ucl/file.hpp"
#include "com_audacia_opentools_casiopv_addinwiz_AddInJNIComm.h"

#include "main.hpp"

extern "C"
{


#ifdef __BORLANDC__
#pragma argsused
#endif
HINSTANCE hGlobalInstance;
int WINAPI DllMain (HINSTANCE hInst, unsigned long reason, void* lpReserved)
{
    hGlobalInstance = hInst;
    return (1);
}

int WINAPI DllEntryPoint (HINSTANCE hInst, unsigned long reason, void* lpReserved)
{
    return DllMain (hInst, reason, lpReserved);
}


}


std::string getModulePath (HINSTANCE hInst)
{
  char str[MAX_PATH];
  GetModuleFileName (hInst, str, MAX_PATH);
  return (ucl::extractFilePath (str));
}

std::string getPV2SDKPath ()
{
    return (ucl::IniFile (getModulePath (hGlobalInstance)
          + "..\\toolsets\\PVSDK\\Settings.ini")["PV2SDK Paths"]["SDKPath"]);
}

void correctPathSlashes (std::string& path)
{
    for (int n = path.size () - 1; n >= 0; --n)
      if (path[n] == '/')
        path[n] = '\\';
}

std::vector <char> concatStrings (int num, const char*, ...)
{
    std::vector <char> res;
    std::va_list args;
    const char* carg;
    int csize, ssize;

    res.reserve (500);

    va_start (args, num);
    for(; num > 0; --num)
    {
        carg = va_arg (args, const char*);
        csize = res.size ();
        ssize = csize + strlen (carg);
        res.resize (ssize + 1 /* \0 */);
        strcpy (&res[csize], carg);
    }
    va_end (args);

    res.resize (res.size () + 1);
    res[res.size () - 1] = '\0';
    return (res);
}



JNIEXPORT void JNICALL Java_com_audacia_opentools_casiopv_addinwiz_AddInJNIComm_debugMethod
  (JNIEnv* env, jclass, jstring jstr)
{
    const char* str = env->GetStringUTFChars (jstr, NULL);
    MessageBox (NULL, str, "DebugMessage:", MB_OK);

    env->ReleaseStringUTFChars (jstr, str);
}



JNIEXPORT void JNICALL Java_com_audacia_opentools_casiopv_addinwiz_AddInJNIComm_nativeGetPV2SDKPath
  (JNIEnv* env, jclass cl, jobject sbuf)
{
    std::string retval = getPV2SDKPath ();

        // Obtain the Java StringBuffer class handle that corresponds to the
        // Java StringBuffer object handle.
    cl = env->GetObjectClass (sbuf);

        // Obtain the method ID for the StringBuffer append method which takes
        // a StringBuffer object reference argument and returns a String object
        // reference.
    jmethodID mid =
        env->GetMethodID (cl, "append", "(Ljava/lang/String;)Ljava/lang/StringBuffer;");

        // If this method does not exist then return.
    if (mid == 0)
    {
        MessageBox (NULL, "Method does not exist", "JNI Error", MB_ICONERROR);
        return;
    }

        // Create a new Java String object and populate it with the environment
        // variable value.  Obtain a handle to this object.
    jstring _jstring = env->NewStringUTF ((const char *) retval.c_str ());

        // Call the StringBuffer object's append method passing the handle to
        // the new Java String object.
    env->CallObjectMethod (sbuf, mid, _jstring);
}




JNIEXPORT jboolean JNICALL Java_com_audacia_opentools_casiopv_addinwiz_AddInJNIComm_createPVSDKProject
  (JNIEnv* env, jclass, jstring jProjName, jboolean jIsLibrary)
{
    SHFILEOPSTRUCT shfo;
    std::string projfile;
    FILE* srcfile;
    FILE* dstfile;
    int c;
    bool fores;


    const char* projName = env->GetStringUTFChars (jProjName, NULL);
    std::string srcbase = getModulePath (hGlobalInstance);
    std::string src1 = srcbase + (jIsLibrary
                                ? "..\\templates\\PVSDK\\projlib\\*.*"
                                : "..\\templates\\PVSDK\\projapp\\*.*");
    std::string dst = getPV2SDKPath () + "\\C\\" + projName;
    std::vector <char> vsrc = concatStrings (1, src1.c_str ());
    std::vector <char> vdst = concatStrings (1, dst.c_str ());


    CreateDirectory (dst.c_str (), NULL);

    projfile = srcbase + (jIsLibrary
                        ? "..\\templates\\PVSDK\\projlib.cbx"
                        : "..\\templates\\PVSDK\\projapp.cbx");


    srcfile = fopen (projfile.c_str (), "r");
    if (srcfile)
    {
        dstfile = fopen ((dst + "\\" + projName + ".cbx").c_str (), "w");
        if (dstfile)
            while ((c = fgetc (srcfile)) != EOF)
            {
                if (c == '%')
                {
                    fgetc (srcfile); /* "s" */
                    fputs (projName, dstfile);
                }
                else
                    fputc (c, dstfile);
            }

        fclose (dstfile);
        fclose (srcfile);
    }

    ZeroMemory (&shfo, sizeof (SHFILEOPSTRUCT));
    shfo.wFunc = FO_COPY;
    shfo.fFlags = FOF_SILENT | FOF_NOCONFIRMATION | FOF_NOCONFIRMMKDIR;
    shfo.pTo   = &vdst[0];
    shfo.pFrom = &vsrc[0];

    fores = (SHFileOperation (&shfo) == 0);

    MoveFile ((dst + "\\proj.cbx.local").c_str (), (dst + "\\" + projName + ".cbx.local").c_str ());

    env->ReleaseStringUTFChars (jProjName, projName);
    return fores;
}


HWND findSIMWindow (const std::string& projfile)
{
    HWND hSIMWin;
    char buf[512];
    std::string simtitle = "SIM3022";


    if (!projfile.empty ())
        simtitle += " - " + projfile;

    hSIMWin = FindWindow ("TMainForm", simtitle.c_str ());
    if (!hSIMWin)
    {
        hSIMWin = FindWindow ("TMainForm", NULL);
        if (!hSIMWin)
            return (NULL);

        GetWindowText (hSIMWin, buf, 512);
        if (strncmp (buf, "SIM3022", 7))
            return (NULL);
    }

    SetWindowPos (hSIMWin, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
    return (hSIMWin);
}

bool startProcess (std::string path, PROCESS_INFORMATION& pi)
{
    STARTUPINFO si;


    si.cb = sizeof (STARTUPINFO);
    si.lpReserved = NULL;
    si.lpDesktop = NULL;
    si.lpTitle = NULL;
    si.cbReserved2 = 0;
    si.lpReserved2 = NULL;
    si.dwFlags = 0;
    return (CreateProcess (NULL, &path[0], NULL, NULL, FALSE,
        NORMAL_PRIORITY_CLASS, NULL, ucl::extractFilePath (path).c_str (), &si, &pi));
}





const EXTKEY_SHIFT = 1;
const EXTKEY_CTRL  = 2;
const EXTKEY_ALT   = 4;

inline void sendKeyDown (BYTE bVK)
{
    keybd_event (bVK, 0, 0, 0);
}
inline void sendKeyUp (BYTE bVK)
{
    keybd_event (bVK, 0, KEYEVENTF_KEYUP, 0);
}
void sendKeyPress (BYTE bVK, DWORD extkeys = 0)
{
    if (extkeys & EXTKEY_SHIFT)
        sendKeyDown (VK_SHIFT);
    if (extkeys & EXTKEY_CTRL)
        sendKeyDown (VK_CONTROL);
    if (extkeys & EXTKEY_ALT)
        sendKeyDown (VK_MENU);

    keybd_event (bVK, 0, 0, 0);
    keybd_event (bVK, 0, KEYEVENTF_KEYUP, 0);

    if (extkeys & EXTKEY_SHIFT)
        sendKeyUp (VK_SHIFT);
    if (extkeys & EXTKEY_CTRL)
        sendKeyUp (VK_CONTROL);
    if (extkeys & EXTKEY_ALT)
        sendKeyUp (VK_MENU);
}


void sendText (const std::string& text)
{
    int l = text.size ();
    SHORT sVK;


    for (int i = 0; i < l; ++i)
    {
        sVK = VkKeyScan (text[i]);
        sendKeyPress ((BYTE) sVK, sVK >> 8);
    }
}


void loadSIMProject (const std::string& path, bool debug)
{
    sendKeyPress ('F', EXTKEY_ALT);
    sendKeyPress ('R');
    sendKeyPress ('4');

    Sleep (500);

    if (debug)
    {   /* open map file */
        sendKeyPress ('S', EXTKEY_ALT);
        sendKeyPress ('L');

        Sleep (250);

        sendText (path);
        sendText ("\\PV2BUILD\\ForDebug.MAP");

        sendKeyPress (VK_RETURN);

        Sleep (125);
    }

    sendKeyPress (VK_F9);
}


void closeSIM (const std::string& dstfile)
{
    if (!findSIMWindow (dstfile))
        return;

    Sleep (100);

    sendKeyPress (VK_ESCAPE);
    Sleep (100);

    sendKeyPress ('F', EXTKEY_ALT);
    sendKeyPress ('C');
    Sleep (100);

    sendKeyPress ('N');
    Sleep (100);

    sendKeyPress (VK_F4, EXTKEY_ALT);
}



int writeRegistryKey (const std::string& projfile)
{
    HKEY hKey = NULL;


        /* write project entry to registry */
    if (RegCreateKey (HKEY_CURRENT_USER, "Software\\CASIO\\SIM3022\\RecentFiles",
                      &hKey) != ERROR_SUCCESS)
        return (1);
    RegSetValueEx (hKey, "4", 0, REG_SZ, projfile.c_str (), projfile.size () + 1);
    RegCloseKey (hKey);
    return (0);
}

JNIEXPORT jobjectArray JNICALL Java_com_audacia_opentools_casiopv_addinwiz_AddInJNIComm_getPV2SDKLibraries
  (JNIEnv* env, jclass)
{
    std::vector <std::string> libs;
    WIN32_FIND_DATA wfd;
    HANDLE hFiles;
    int c, size;
    jclass cl;
    jobjectArray array;
    jstring string;


    hFiles = FindFirstFile ((getPV2SDKPath () + "\\C\\Com_Lib\\S\\*.lib").c_str (), &wfd);
    if (hFiles != INVALID_HANDLE_VALUE)
    {
        libs.reserve (4);
        do
        {
            c = strlen (wfd.cFileName);
            if (c < 4)
                continue;
            if (strcmp (wfd.cFileName + c - 4, ".lib"))
                continue;
            if (strcmp (wfd.cFileName, "libc.lib") == 0)
                continue;
            wfd.cFileName[c - 4] = '\0';
            libs.push_back (wfd.cFileName);
        } while (FindNextFile (hFiles, &wfd));
    }

    size = libs.size ();
    cl = env->FindClass ("java/lang/String");
    array = env->NewObjectArray (size, cl, NULL);
    for (int i = 0; i < size; ++i)
    {
        string = env->NewStringUTF (libs[i].c_str ());
        env->SetObjectArrayElement (array, i, string);
        env->DeleteLocalRef (string);
    }

    return array;
}


JNIEXPORT jboolean JNICALL Java_com_audacia_opentools_casiopv_addinwiz_AddInJNIComm_runPVSDKProject
  (JNIEnv* env, jclass, jstring jName, jstring jPath, jboolean jdebug)
{
    static bool threadActive = false;
    static simexitthreaddata_t setd;
    static DWORD threadID;

    PROCESS_INFORMATION pi;
    bool bigscreen;
    int fwnd = 8;
    HWND hSimWnd;


    const char* projFile = env->GetStringUTFChars (jName, NULL);
    const char* szProjPath = env->GetStringUTFChars (jPath, NULL);
    std::string projPath = szProjPath;
    correctPathSlashes (projPath);
    std::string sdkpath = getPV2SDKPath ();
    std::string projName = ucl::extractFileName (projFile);
    std::string destfile = std::string (projPath) + "\\PV2BUILD\\project.cpj";


    bigscreen = (GetSystemMetrics (SM_CXSCREEN) >= 1280);
    ucl::IniFile ifs (getModulePath (hGlobalInstance) + "..\\templates\\PVSDK\\"
                    + (bigscreen
                     ? "\\projdbg1280.cpj"
                     : "\\projdbg1024.cpj"));

    ifs["GENERAL"]["ProjectName"] = projName;
    ifs["GENERAL"]["CurrentDir"]  = sdkpath + "\\";
    ifs["GENERAL"]["SourceDir"]   = sdkpath + "\\C\\" + projName + "\\";
    ifs["GENERAL"]["SourceDir"]   = std::string (projPath) + "\\";
    ifs["CSGROUP5"]["CHIPFILE3"]  = ucl::extractRelativePath (sdkpath, projPath)
                                  + (jdebug ? "PV2BUILD\\OBJDBG\\" : "PV2BUILD\\OBJREL\\")
                                  + projName + ".BIN";

    ifs.saveToFile (std::string (projPath) + "\\PV2BUILD\\project.cpj");


    writeRegistryKey (destfile);
    if (startProcess (sdkpath + "\\SIM\\Sim3022.exe", pi))
    {
        CloseHandle (pi.hProcess);
        CloseHandle (pi.hThread);
    }
    while ((hSimWnd = findSIMWindow (std::string ())) == NULL)
    {
        Sleep (125);
        if (--fwnd <= 0)
            break;
    }

    env->ReleaseStringUTFChars (jName, projFile);
    env->ReleaseStringUTFChars (jPath, szProjPath);

    if (hSimWnd)
    {
        loadSIMProject (projPath, jdebug);

        Sleep (750);

        if (!threadActive)
        {
            setd.hEventReady = CreateEvent (NULL, TRUE, FALSE, NULL);
            CreateThread (NULL, 0, ThreadProc, &setd, 0, &threadID);
            WaitForSingleObject (setd.hEventReady, INFINITE);
            threadActive = true;
        }
        setd.destfile = destfile.c_str ();
        setd.xpos = bigscreen ? 653 : 643;
        SetWindowPos (setd.hWnd, HWND_TOP, setd.xpos, 22, 0, 0, SWP_NOSIZE);
        ShowWindow (setd.hWnd, SW_SHOW);
    }

    return (hSimWnd ? true : false);
}


