//---------------------------------------------------------------------------
#include <windows.h>
#include <string>
#pragma hdrstop

#include "main.hpp"

//---------------------------------------------------------------------------


static const char* windowClassName = "SIMExitWindowClass";
static bool classRegistered = false;

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    simexitthreaddata_t* setd;
    static HWND hWBtn = NULL;
    HINSTANCE hInst;

    setd = (simexitthreaddata_t*) GetWindowLong (hWnd, 0);
    switch (msg)
    {
    case WM_CREATE:
        hWBtn = CreateWindowEx (0, "button", "Exit SIM",
            WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, 8, 8, 144, 25,
            hWnd, (HMENU) IDB_EXIT, (HINSTANCE) GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
        break;
    case WM_COMMAND:
        if ((HIWORD (wParam) == BN_CLICKED) && (LOWORD (wParam) == IDB_EXIT))
        {
            ShowWindow (hWnd, SW_HIDE);
            if (findSIMWindow (setd->destfile))
                closeSIM (setd->destfile);
        }
            /*SendMessage (hWnd, WM_CLOSE, 0, 0);*/
        break;
    case WM_CLOSE:
        hInst = (HINSTANCE) GetWindowLong (hWnd, GWL_HINSTANCE);
        if (hWBtn)
            DestroyWindow (hWBtn);
        hWBtn = NULL;
        DestroyWindow (hWnd);
        UnregisterClass (windowClassName, hInst);
        break;
    case WM_DESTROY:
        PostQuitMessage (0);
        break;
    default:
        return DefWindowProc (hWnd, msg, wParam, lParam);
    }
    return 0;
}

DWORD WINAPI ThreadProc (PVOID pParam)
{
    simexitthreaddata_t* setd = (simexitthreaddata_t*) pParam;
    HINSTANCE hInstance;
    WNDCLASSEX wc;
    HWND hBtn;
    HFONT hFont;
    MSG msg;


    /*MessageBox (NULL, setd ? "!=0" : "==0", "setd", 0);
    MessageBox (NULL, setd->destfile, "setd->destfile", 0);
    destfile = setd->destfile;*/
    hInstance = GetModuleHandle (NULL);

    wc.cbSize        = sizeof (WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = sizeof (simexitthreaddata_t*);
    wc.hInstance     = hInstance;
    wc.hIcon         = NULL;
    wc.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = windowClassName;
    wc.hIconSm       = NULL;

    if(!RegisterClassEx (&wc))
    {
        MessageBox (NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return (0);
    }

    if (!classRegistered)
    {
        setd->hWnd = CreateWindowEx (WS_EX_TOOLWINDOW | WS_EX_TOPMOST, windowClassName, "SIMExitWindow",
            WS_POPUP | WS_CAPTION | WS_SYSMENU | WS_VISIBLE, 643, 22, 167, 64,
            NULL, NULL, hInstance, NULL);
        SetWindowLong (setd->hWnd, 0, (long) setd);
        if (!(setd->hWnd))
        {
            MessageBox (NULL, "Window Creation Failed!", "Error!",
                MB_ICONEXCLAMATION | MB_OK);
            return (0);
        }
    }

    SetEvent (setd->hEventReady);

    ShowWindow (setd->hWnd, SW_HIDE);
    UpdateWindow (setd->hWnd);


    while (GetMessage (&msg, setd->hWnd, 0, 0) > 0)
    {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
    }

    ExitThread (msg.wParam);
    return (0);
}
//---------------------------------------------------------------------------
