/*
 * modeldef.h
 *
 * common defines model dependent
 */
#ifndef _MODELDEF_H
#define _MODELDEF_H

#ifdef __HITACHI__

#include <string.h>
#include <hitachi.h>
#include <setjmp.h>
#include "libc.h"
#include "define.h"


#undef FILE_OPEN_MODE
#define FILE_OPEN_MODE IMB_FILE_OPEN_MODE
#undef FILE_SECRET_MODE
#define FILE_SECRET_MODE IMB_FILE_SECRET_MODE

#define FAR /* nothing */
#define NEAR /* nothing */
#define far_strcpy strcpy
#define far_strncpy strncpy
#define far_strcmp strcmp
#define far_strncmp strncmp
#define far_memcpy memcpy
#define far_strchr strchr
#define far_strrchr strrchr
#define far_memset memset
#define far_strlen strlen
#define far_strcat strcat

/* types of defined size */
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
#endif

#ifdef LSI_C

#include <stdrom.h>
#include "libc.h"
#include "l_libc.h"
#include "define.h"
#include "l_define.h"

#define FAR far
#define NEAR near


/* types of defined size */
typedef long int int32;
typedef unsigned long int uint32;
typedef int int16;
typedef unsigned int uint16;

/* FLASH data buffer (binaryBuffer 3KB, correct version)*/
typedef struct _CFILE_BUF {
  byte	fsb_main_entry_;			/* MainEntryNo. */
  byte	fsb_sub_entry_;				/* SubEntryNo.  */

  byte	fsb_scrt_info_;				/* SecretInformation */
  byte	fsb_ararm_chk_;				/* AlarmCheckInformation */

  byte	fsb_todo_chek_;				/* TODO CheckInformation */
  byte	fsb_todo_rank_;				/* TODO RankInformation  */

  byte	fsb_date1_buf_[8];			/* Date/DueDate */
  byte	fsb_date2_buf_[8];			/* CheckDate     */
  byte	fsb_date_aram_[8];			/* AlarmDate     */
  byte	fsb_time1_buf_[4];			/* Time/DueTime(From)    */
  byte	fsb_time2_buf_[4];			/* Time/DueTime(To)      */
  byte	fsb_time3_buf_[4];			/* CheckTime             */
  byte	fsb_time_aram_[4];			/* AlarmTime             */

  byte	fsb_date_srch_[8];			/* SearchBuffer Date      */
  byte	fsb_time_srch_[4];			/* SearchBuffer Time      */
  byte	fsb_text_srch_[33];			/* SearchBuffer RealData(text) */

  union{
    struct{
      byte	fsb_text_buf_[2048+1];/* Buffer to store real data (TEXT)    */
    }text;

    struct{
      byte	dummy_16by[22];		/* MemoryManagementWork      */
      word	char_num;			/* BinaryDataCapacity        */
      byte	bin_buf[3072+40];		/* Buffer to store real data (BINARY) 3KB */
    }bin;

  }fbuf;
} CFILE_BUF;
#else
typedef FILE_BUF CFILE_BUF;
#endif

#endif
